' Sparrow-Ereigniszaehler 0 - 99999

' Zaehleingang PinB.0
' Abfragetaster an PinB.2
' Buzzer an PortB.4
' rote LED an PortB.3
' gruene LED an PortB.1
' Ergebnis wird ziffernweise als eine Reihe von Blinksignalen und Piepstoenen ausgegeben
' Ziffer 0: rote LED / langer tiefer Ton
' Ziffern 1-9:  gruene LED /kurze hoehere Toene

' Compiler: BASCOM 2.0.7.5 Demo


$regfile = "Attiny13.dat"
$crystal = 1200000
$hwstack = 32
$swstack = 4
$framesize = 4

DDRB =  &B00011010
PORTB = &B00000101
DIDR0 = &B00011010
GIMSK.PCIE = 1
PCMSK.PCINT0 = 1
PCMSK.PCINT2 = 1
SREG.7 = 1

On PCINT0 Onpcint

Buzzer Alias PortB.4
Zaehleing Alias PinB.0
Abfrage Alias PinB.2
Rot Alias PortB.3
Gruen Alias PortB.1

Const Lang = 200                                              ' Laenge Sound
Const Kurz = 100
Const Tief = 300                                              ' Tonhoehe Sound
Const Hoch = 100

Dim I As Byte
Dim M As Byte
Dim N As Long
Dim K As Byte
Dim MS As Byte

Dim Event As Long
Dim Carry As Long
Dim Divisor As Long



Do
   If Abfrage = 0 Then
      Gosub Ausgabe
      Powerdown
   End If
Loop



' Ausgabe des Zaehlerstandes

Ausgabe:

   Carry = Event
   Divisor = 10000
   For K = 1 to 5
      N = Carry / Divisor
      Gosub Beep
      Carry = Carry Mod Divisor
      Divisor = Divisor / 10
   Next

Return



'Tonerzeugung

Beep:

   If N = 0 Then
      Rot = 1
      Sound Buzzer , Lang , Tief
      Rot = 0
   End If
   For I = 1 To N
      Gruen = 1
      Sound Buzzer , Kurz , Hoch
      Gruen = 0
      Waitms Kurz
   Next
   Wait 1

Return

End

'----------------------------------------------------------

Onpcint:

If PinB.0 = 0 Then
   Waitms 10
   If PinB.0 = 0 Then
      Incr Event
   End If
End If
Return
